Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class BorderLayout

    java.lang.Object
      |
      +--java.awt.BorderLayout

All Implemented Interfaces:
  LayoutManager, LayoutManager2, Serializable

public class BorderLayout
extends Object
implements LayoutManager2, Serializable

A border layout lays out a container, arranging and resizing its components to fit in five regions: north, south, east, west, and center. Each region is identified by a corresponding constant: `NORTH`, `SOUTH`, `EAST`, `WEST`, and `CENTER`. When adding a component to a container with a border layout, use one of these five constants, for example:

        Panel p = new Panel();
        p.setLayout(new BorderLayout());
        p.add(new Button("Okay"), BorderLayout.SOUTH);

As a convenience, BorderLayout interprets the absence of a string specification the same as the constant `CENTER`:

        Panel p2 = new Panel();
        p2.setLayout(new BorderLayout());
        p2.add(new TextArea());  // Same as p.add(new TextArea(), BorderLayout.CENTER);

In addition, BorderLayout supports four relative positioning constants, `BEFORE_FIRST_LINE`, `AFTER_LAST_LINE`, `BEFORE_LINE_BEGINS`, and `AFTER_LINE_ENDS`. In a container whose ComponentOrientation is set to `ComponentOrientation.LEFT_TO_RIGHT`, these constants map to `NORTH`, `SOUTH`, `WEST`, and `EAST`, respectively

Mixing the two types of constants can lead to unpredicable results. If you use both types, the relative constants will take precedence. For example, if you add components using both the `NORTH` and `BEFORE_FIRST_LINE` constants in a container whose orientation is `LEFT_TO_RIGHT`, only the `BEFORE_FIRST_LINE` will be layed out.

NOTE: Currently (in the Java 2 platform v1.2), BorderLayout does not support vertical orientations. The `isVertical` setting on the container's ComponentOrientation is not respected.

The components are laid out according to their preferred sizes and the constraints of the container's size. The `NORTH` and `SOUTH` components may be stretched horizontally; the `EAST` and `WEST` components may be stretched vertically; the `CENTER` component may stretch both horizontally and vertically to fill any space left over.

Here is an example of five buttons in an applet laid out using the `BorderLayout` layout manager:

The code for this applet is as follows:

>      import java.awt.*;
>      import java.applet.Applet;

>      public class buttonDir extends Applet {
>        public void init() {
>          setLayout(new BorderLayout());
>          add(new Button("North"), BorderLayout.NORTH);
>          add(new Button("South"), BorderLayout.SOUTH);
>          add(new Button("East"), BorderLayout.EAST);
>          add(new Button("West"), BorderLayout.WEST);
>          add(new Button("Center"), BorderLayout.CENTER);
>        }
>      }

Since:
  JDK1.0
See Also:
  `Container.add(String, Component)`, `ComponentOrientation`, Serialized Form

Field Summary
`static String` | `AFTER_LAST_LINE` The component comes after the last line of the layout's content.
`static String` | `AFTER_LINE_ENDS` The component goes at the end of the line direction for the layout.
`static String` | `BEFORE_FIRST_LINE` The component comes before the first line of the layout's content.
`static String` | `BEFORE_LINE_BEGINS` The component goes at the beginning of the line direction for the layout.
`static String` | `CENTER` The center layout constraint (middle of container).
`static String` | `EAST` The east layout constraint (right side of container).
`static String` | `NORTH` The north layout constraint (top of container).
`static String` | `SOUTH` The south layout constraint (bottom of container).
`static String` | `WEST` The west layout constraint (left side of container).

Constructor Summary
`BorderLayout()` Constructs a new border layout with no gaps between components.
`BorderLayout(int hgap, int vgap)` Constructs a border layout with the specified gaps between components.

Method Summary
`void` | `addLayoutComponent(Component comp, Object constraints)` Adds the specified component to the layout, using the specified constraint object.
`void` | `addLayoutComponent(String name, Component comp)` Adds the specified component with the specified name to the layout.
`int` | `getHgap()` Returns the horizontal gap between components.
`float` | `getLayoutAlignmentX(Container parent)` Returns the alignment along the x axis.
`float` | `getLayoutAlignmentY(Container parent)` Returns the alignment along the y axis.
`int` | `getVgap()` Returns the vertical gap between components.
`void` | `invalidateLayout(Container target)` Invalidates the layout, indicating that if the layout manager has cached information it should be discarded.
`void` | `layoutContainer(Container target)` Lays out the container argument using this border layout.
`Dimension` | `maximumLayoutSize(Container target)` Returns the maximum dimensions for this layout given the components in the specified target container.
`Dimension` | `minimumLayoutSize(Container target)` Determines the minimum size of the `target` container using this layout manager.
`Dimension` | `preferredLayoutSize(Container target)` Determines the preferred size of the `target` container using this layout manager, based on the components in the container.
`void` | `removeLayoutComponent(Component comp)` Removes the specified component from this border layout.
`void` | `setHgap(int hgap)` Sets the horizontal gap between components.
`void` | `setVgap(int vgap)` Sets the vertical gap between components.
`String` | `toString()` Returns a string representation of the state of this border layout.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### NORTH

    public static final String NORTH

  The north layout constraint (top of container).

### SOUTH

    public static final String SOUTH

  The south layout constraint (bottom of container).

### EAST

    public static final String EAST

  The east layout constraint (right side of container).

### WEST

    public static final String WEST

  The west layout constraint (left side of container).

### CENTER

    public static final String CENTER

  The center layout constraint (middle of container).

### BEFORE_FIRST_LINE

    public static final String BEFORE_FIRST_LINE

  The component comes before the first line of the layout's content. For Western, top-to-bottom, left-to-right orientations, this is equivalent to NORTH.
  See Also:
    `Component.getComponentOrientation()`
  Since:
    1.2

### AFTER_LAST_LINE

    public static final String AFTER_LAST_LINE

  The component comes after the last line of the layout's content. For Western, top-to-bottom, left-to-right orientations, this is equivalent to SOUTH.
  See Also:
    `Component.getComponentOrientation()`
  Since:
    1.2

### BEFORE_LINE_BEGINS

    public static final String BEFORE_LINE_BEGINS

  The component goes at the beginning of the line direction for the layout. For Western, top-to-bottom, left-to-right orientations, this is equivalent to WEST.
  See Also:
    `Component.getComponentOrientation()`
  Since:
    1.2

### AFTER_LINE_ENDS

    public static final String AFTER_LINE_ENDS

  The component goes at the end of the line direction for the layout. For Western, top-to-bottom, left-to-right orientations, this is equivalent to EAST.
  See Also:
    `Component.getComponentOrientation()`
  Since:
    1.2

Constructor Detail

### BorderLayout

    public BorderLayout()

  Constructs a new border layout with no gaps between components.

### BorderLayout

    public BorderLayout(int hgap,
                        int vgap)

  Constructs a border layout with the specified gaps between components. The horizontal gap is specified by `hgap` and the vertical gap is specified by `vgap`.
  Parameters:
    `hgap` - the horizontal gap.
    `vgap` - the vertical gap.

Method Detail

### getHgap

    public int getHgap()

  Returns the horizontal gap between components.
  Since:
    JDK1.1

### setHgap

    public void setHgap(int hgap)

  Sets the horizontal gap between components.
  Parameters:
    `hgap` - the horizontal gap between components
  Since:
    JDK1.1

### getVgap

    public int getVgap()

  Returns the vertical gap between components.
  Since:
    JDK1.1

### setVgap

    public void setVgap(int vgap)

  Sets the vertical gap between components.
  Parameters:
    `vgap` - the vertical gap between components
  Since:
    JDK1.1

### addLayoutComponent

    public void addLayoutComponent(Component comp,
                                   Object constraints)

  Adds the specified component to the layout, using the specified constraint object. For border layouts, the constraint must be one of the following constants: `NORTH`, `SOUTH`, `EAST`, `WEST`, or `CENTER`.

  Most applications do not call this method directly. This method is called when a component is added to a container using the `Container.add` method with the same argument types.

  Specified by:
    `addLayoutComponent` in interface `LayoutManager2`
  Parameters:
    `comp` - the component to be added.
    `constraints` - an object that specifies how and where the component is added to the layout.
  Throws:
    `IllegalArgumentException` - if the constraint object is not a string, or if it not one of the five specified constants.
  Since:
    JDK1.1
  See Also:
    `Container.add(java.awt.Component, java.lang.Object)`

### addLayoutComponent

    public void addLayoutComponent(String name,
                                   Component comp)

  Deprecated. replaced by `addLayoutComponent(Component, Object)`.

  Description copied from interface: `LayoutManager`
  Adds the specified component with the specified name to the layout.
  Specified by:
    `addLayoutComponent` in interface `LayoutManager`
  Following copied from interface: `java.awt.LayoutManager`
  Parameters:
    `name` - the component name
    `comp` - the component to be added

### removeLayoutComponent

    public void removeLayoutComponent(Component comp)

  Removes the specified component from this border layout. This method is called when a container calls its `remove` or `removeAll` methods. Most applications do not call this method directly.
  Specified by:
    `removeLayoutComponent` in interface `LayoutManager`
  Parameters:
    `comp` - the component to be removed.
  See Also:
    `Container.remove(java.awt.Component)`, `Container.removeAll()`

### minimumLayoutSize

    public Dimension minimumLayoutSize(Container target)

  Determines the minimum size of the `target` container using this layout manager.

  This method is called when a container calls its `getMinimumSize` method. Most applications do not call this method directly.

  Specified by:
    `minimumLayoutSize` in interface `LayoutManager`
  Parameters:
    `target` - the container in which to do the layout.
  Returns:
    the minimum dimensions needed to lay out the subcomponents of the specified container.
  See Also:
    `Container`, `preferredLayoutSize(java.awt.Container)`, `Container.getMinimumSize()`

### preferredLayoutSize

    public Dimension preferredLayoutSize(Container target)

  Determines the preferred size of the `target` container using this layout manager, based on the components in the container.

  Most applications do not call this method directly. This method is called when a container calls its `getPreferredSize` method.

  Specified by:
    `preferredLayoutSize` in interface `LayoutManager`
  Parameters:
    `target` - the container in which to do the layout.
  Returns:
    the preferred dimensions to lay out the subcomponents of the specified container.
  See Also:
    `Container`, `minimumLayoutSize(java.awt.Container)`, `Container.getPreferredSize()`

### maximumLayoutSize

    public Dimension maximumLayoutSize(Container target)

  Returns the maximum dimensions for this layout given the components in the specified target container.
  Specified by:
    `maximumLayoutSize` in interface `LayoutManager2`
  Parameters:
    `target` - the component which needs to be laid out
  See Also:
    `Container`, `minimumLayoutSize(java.awt.Container)`, `preferredLayoutSize(java.awt.Container)`

### getLayoutAlignmentX

    public float getLayoutAlignmentX(Container parent)

  Returns the alignment along the x axis. This specifies how the component would like to be aligned relative to other components. The value should be a number between 0 and 1 where 0 represents alignment along the origin, 1 is aligned the furthest away from the origin, 0.5 is centered, etc.
  Specified by:
    `getLayoutAlignmentX` in interface `LayoutManager2`

### getLayoutAlignmentY

    public float getLayoutAlignmentY(Container parent)

  Returns the alignment along the y axis. This specifies how the component would like to be aligned relative to other components. The value should be a number between 0 and 1 where 0 represents alignment along the origin, 1 is aligned the furthest away from the origin, 0.5 is centered, etc.
  Specified by:
    `getLayoutAlignmentY` in interface `LayoutManager2`

### invalidateLayout

    public void invalidateLayout(Container target)

  Invalidates the layout, indicating that if the layout manager has cached information it should be discarded.
  Specified by:
    `invalidateLayout` in interface `LayoutManager2`

### layoutContainer

    public void layoutContainer(Container target)

  Lays out the container argument using this border layout.

  This method actually reshapes the components in the specified container in order to satisfy the constraints of this `BorderLayout` object. The `NORTH` and `SOUTH` components, if any, are placed at the top and bottom of the container, respectively. The `WEST` and `EAST` components are then placed on the left and right, respectively. Finally, the `CENTER` object is placed in any remaining space in the middle.

  Most applications do not call this method directly. This method is called when a container calls its `doLayout` method.

  Specified by:
    `layoutContainer` in interface `LayoutManager`
  Parameters:
    `target` - the container in which to do the layout.
  See Also:
    `Container`, `Container.doLayout()`

### toString

    public String toString()

  Returns a string representation of the state of this border layout.
  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this border layout.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.